#|#######################################################
sub Old_Gere_Index_Appelants {
    local($nom,$source,$index)=@_;
    $index = "" unless ($index);
    $source = "" unless $source ;
    local($ligne)="";

    local($Routine)="";
    local($num)=0;
    local($fichier)="";
    local($RoutEncour)="";

    local($ref)="";

    @liste_appels_complet=();
    @liste_appels=();

    if ($Appelants{$nom}) {
	@liste_appels_complet = sort keys %{$Appelants{$nom}};
	if (@liste_appels_complet) {
	    $ligne .= "est appel&eacute;e par\n";
	} else {
	    $ligne .= "et n'est pas appeleacute;e.\n";
	}
	$ligne .= "<UL>\n";
	foreach $Routine (@liste_appels_complet) {
	    $fichier=$File_Of_Rout{$Routine} ;
	    $RoutEncour = GetAlias($Routine);
	    GetIncludeCibleOfWrite($fichier); 
	    $RoutineRef=$Routine; 
	    if ($RoutineRef =~ /([\w_]+)\.(h|hh|fh|ch)/i) {
		$ref="$fichier.html";
		$RoutineRef = "$1.$2";
		$ligne .= "<LI><A HREF=\"$ref\" ".Target("$source").index::OnClick("$fichier","","$index").">$Routine</A>";
	    } else {
		$ref=CodeName($fichier,"$source").".html#R_$RoutineRef";
		$ligne .= "<LI><A HREF=\"$ref\" ".Target("$source").index::OnClick("$fichier","R_$RoutineRef","$index").">$Routine</A>";
	    }
	    $numloc=1 ;
	    foreach $num (sort numerique split(/ /, ${$Appelants{$nom}}{$Routine})) {
	        if ($numloc) {
		    $numloc=0 ;
		} else {
		    $ligne .= " - ";
		}
		$ligne .= " (<A HREF=\"".CodeName($fichier,"$source").".html#C_$RoutineRef$num\" ".Target("$source").index::OnClick("$fichier","R_$RoutineRef","$index").">$num</A>)\n";
	    }
	}
	$ligne .= "</UL>\n";
    }
    return "$ligne";
}

#|#######################################################
sub Old_Gere_Index_Appellees {
    local($nom,$source,$index)=@_;
    $index = "" unless ($index);
    $source = "" unless $source ;
    local($ligne)="";
    local($Called_local)="";
    local($num)="";
    local($fichier)="";
    local($Called_Minus)="";
    local($headligne)="";
    local(@liste_appels_complet)=();

    if ($Appellees{$nom}) {
	$headligne .= "$nom";
	@liste_appels_complet = sort keys %{$Appellees{$nom}} ;
	if (@liste_appels_complet) {
	    $headligne .= " appelle ";
	} else {
	    $headligne .= " n'appelle aucune fonction.\n";
	}
	$ligne .=  "<UL>\n";
	$fichier=$File_Of_Rout{$nom} ;
	foreach $Called_local (@liste_appels_complet) {
	    $Called_Minus = GetAlias($Called_local);
	    $Reference = "";
	    if ($File_Of_Rout{$Called_local}) {
		$Reference = $Called_local ;
	    } elsif ($R_Declar{$Called_Minus}) {
		$Reference = $R_Declar{$Called_Minus} ;
	    }
	    $ligne .= "<LI>";
	    if ($Reference) {
		$ligne .= "<A HREF=\"".CodeName($File_Of_Rout{$Reference},"$source").".html#R_$Reference\" ".Target("$source").index::OnClick("$File_Of_Rout{$Reference}","R_$Reference","$index").">$Called_local</A>";
		$headligne .= "<A HREF=\"".CodeName($File_Of_Rout{$Reference},"$source").".html#R_$Reference\" ".Target("$source").index::OnClick("$File_Of_Rout{$Reference}","R_$Reference","$index").">$Called_local</A>, ";
	    } else {
		$ligne .= "<I>$Called_local</I>";
		$headligne .= "<I>$Called_local</I>, ";
	    }
	    $numloc=1 ;
	    foreach $num (sort numerique split(/ /, ${$Appellees{$nom}}{$Called_local})) {
# Il semble que tout ceci peut se simplifier...
	        if ($numloc) {
		    $numloc=0 ;
		} else {
		    $ligne .= " - ";
		}
		$ligne .=  "(<A HREF=\"".CodeName($fichier,"$source").".html#C_$nom$num\" ".Target("$source").index::OnClick("$fichier","R_$nom","$index").">$num</A>)\n";
	    }
	}
	$ligne .= "</UL>\n";
    }
    $headligne =~ s/(.*),/"${1}:\n"/geom ;
    return "$headligne$ligne";
} ;
#|#######################################################
sub OldRefDeclare {
    local($ligne)=@_;
    local($outligne)="";
    $ligne = quotemeta "$ligne";
    $outligne=`print STDOUT $ligne | hevea`;
    return ($outligne);
}
#|#######################################################
sub OldAddCallTree {
    local($num,$file,$Called_local,$Routine,$Reference)=@_;
    if ($Appellees{$Routine}) {
	$Appellees{$Routine} .=" :$Called_local:$num:$file" ;
    } else {
	$Appellees{$Routine} =":$Called_local:$num:$file" ;
    }
    if ( $Appelants{$Reference} ) {
	$Appelants{$Reference} .=" :$Routine:$num:$file" ;
    } else {
	$Appelants{$Reference} =":$Routine:$num:$file" ;
    }
}
#|#######################################################
sub Old_Index_T_Latex {
# index des fonctions
    open(LATEX,">$main::DIRE/texindex.tex");
    &Ouvre_SLatex ;
    &Ouvre_LLatex ;
    if (@main::programmes) {
    @liste=sort @main::programmes ;
    print LATEX "\\chapter{Programme}\n" ;
    print LATEX "On met le num\\'ero de ligne d'appel ou de d\\'efinition entre parenth\\`eses.\n" ;
    print LATEX "\\hfill\\\\\\noindent\n" ;
    print LATEX "\\begin{enumerate}\n" ;
    while (@liste) {
	($Routine,$file,$href)=split(/:/,shift @liste);
	$nom = $Routine ;
	$NOM = GetFullDeclare($nom) ;
	$Nom = $nom ;
	$Nom =~ s/_/\\_/g ;
	$File = $file ;
	$File =~ s/_/\\_/g ;
	print LATEX "%\\begin{$Nom}\n" ;
	print LATEX "\\item {\\bf $Nom}\\label{$NOM} est d\\'eclar\\'e dans {\\bf $File}, ($main::L_Declar{$nom}).\n" ;
	&Gere_Latex ;
	print LATEX "%\\end{$Nom}\n" ;
    }
    print LATEX "\\end{enumerate}\n" ;
    }
    if (@main::functions) {
    print LATEX "\\chapter{Liste alphab\\'etique des fonctions.}\n" ;
    print LATEX "On met le num\\'ero de ligne d'appel ou de d\\'efinition entre parenth\\`eses.\n" ;
    print LATEX "\\hfill\\\\\\noindent\n" ;
    print LATEX "\\begin{enumerate}\n" ;
    @liste=sort @main::functions ;
    while (@liste) {
	($Routine,$file,$href)=split(/:/,shift @liste);
	$nom = $Routine ;
	$NOM = GetFullDeclare($nom) ;
	$Nom = $nom ;
	$Nom =~ s/_/\\_/g ;
	$File = $file ;
	$File =~ s/_/\\_/g ;
	print LATEX "%\\begin{$Nom}\n" ;
	print LATEX "\\item {\\bf $Nom}\\label{$NOM} est d\\'eclar\\'ee dans {\\bf $File}, ($main::L_Declar{$nom}).\n" ;
	&Gere_Latex ;
	print LATEX "%\\end{$Nom}\n" ;
    }
    print LATEX "\\end{enumerate}\n" ;
    }
    if (@main::routines) {
    print LATEX "\\chapter{Liste alphab\\'etique des routines.}\n" ;
    print LATEX "On met le num\\'ero de ligne d'appel ou de d\\'efinition entre parenth\\`eses.\n" ;
    print LATEX "\\hfill\\\\\\noindent\n" ;
    print LATEX "\\begin{enumerate}\n" ;
    @liste=sort @main::routines ;
    while (@liste) {
	($Routine,$file,$href)=split(/:/,shift @liste);
	$nom = $Routine ;
	$NOM = GetFullDeclare($nom) ;
	$Nom = $nom ;
	$Nom =~ s/_/\\_/g ;
	$File = $file ;
	$File =~ s/_/\\_/g ;
	print LATEX "%\\begin{$Nom}\n" ;
	print LATEX "\\item {\\bf $Nom}\\label{$NOM} est d\\'eclar\\'ee dans {\\bf $File}, ($main::L_Declar{$nom}).\n" ;
	&Gere_Latex ;
	print LATEX "%\\end{$Nom}\n" ;
    }
    print LATEX "\\end{enumerate}\n" ;
    }
    close (LATEX) ;
}
#%###################################################
sub HTML_Private_Called {
    local($htmlligne,$latexligne) = Index_Private_Called(@_) ;
    return($htmlligne);
}
#%###################################################
sub HTML_Private_Calls {
    local($htmlligne,$latexligne) = Index_Private_Calls(@_) ;
    return($htmlligne);
}
#%###################################################
sub HTML_Private_Uses {
    local($htmlligne,$latexligne) = Index_Private_Uses(@_) ;
    return($htmlligne);
}
#%###################################################
sub HTML_Private_Used {
    local($htmlligne,$latexligne) = Index_Private_Used(@_) ;
    return($htmlligne);
}
#|#######################################################
sub New_Index_T_Latex {
# index des fonctions
    open(LATEX,">$main::DIRE/texindex.tex");
    &Ouvre_SLatex ;
    &Ouvre_LLatex ;
    if (@main::programmes) {
    @liste=sort @main::programmes ;
    print LATEX "\\chapter{Programme}\n" ;
    print LATEX "On met le num\\'ero de ligne d'appel ou de d\\'efinition entre parenth\\`eses.\n" ;
    print LATEX "\\hfill\\\\\\noindent\n" ;
    print LATEX "\\begin{enumerate}\n" ;
    while (@liste) {
	($Routine,$file,$href)=split(/:/,shift @liste);
	local($RoutineCasei) = main::GetLowerCase($Routine) ;
	local($latexRoutine) = main::LaTeXProtect($RoutineCasei);
	local($tag) = "R_$RoutineCasei";
	local($latexFile) = main::LaTeXProtect($file);
	print LATEX "%\\begin{$latexRoutine}\n" ;
	print LATEX "\\item {\\bf $latexRoutine}\\label{$tag} est d\\'eclar\\'e dans {\\bf $latexFile}, ($main::L_Declar{$RoutineCasei}).\n" ;
	print LATEX "\\begin{itemize}\n" ;
	local($totalRoutine)=GetFullDeclare($RoutineCasei) ;
	print "totalRoutine=$totalRoutine\n";
	print LATEX LATEX_Private_Called($totalRoutine,"source") ;
	print LATEX LATEX_Private_Calls($totalRoutine,"source") ;
#	&Gere_Latex_Appelants ;
#	&Gere_Latex_Appellees ;
	print LATEX Gere_Latex_Include($RoutineCasei,$latexRoutine,$file) ;
	print LATEX "\\end{itemize}\n" ;
	print LATEX "%\\end{$latexRoutine}\n" ;
    }
    print LATEX "\\end{enumerate}\n" ;
    }
    if (@main::functions) {
    print LATEX "\\chapter{Liste alphab\\'etique des fonctions.}\n" ;
    print LATEX "On met le num\\'ero de ligne d'appel ou de d\\'efinition entre parenth\\`eses.\n" ;
    print LATEX "\\hfill\\\\\\noindent\n" ;
    print LATEX "\\begin{enumerate}\n" ;
    @liste=sort @main::functions ;
    while (@liste) {
	($Routine,$file,$href)=split(/:/,shift @liste);
	local($RoutineCasei) = main::GetLowerCase($Routine) ;
	local($latexRoutine) = main::LaTeXProtect($RoutineCasei);
	local($tag) = "R_$RoutineCasei";
	local($latexFile) = main::LaTeXProtect($file);
	print LATEX "%\\begin{$latexRoutine}\n" ;
	print LATEX "\\item {\\bf $latexRoutine}\\label{$tag} est d\\'eclar\\'ee dans {\\bf $latexFile}, ($main::L_Declar{$RoutineCasei}).\n" ;
	print LATEX "\\begin{itemize}\n" ;
	local($totalRoutine)=GetFullDeclare($RoutineCasei) ;
	print "totalRoutine=$totalRoutine\n";
	print LATEX LATEX_Private_Called($totalRoutine,"source") ;
	print LATEX LATEX_Private_Calls($totalRoutine,"source") ;
	print LATEX Gere_Latex_Include($RoutineCasei,$latexRoutine,$file) ;
	print LATEX "\\end{itemize}\n" ;
	print LATEX "%\\end{$latexRoutine}\n" ;
    }
    print LATEX "\\end{enumerate}\n" ;
    }
    if (@main::routines) {
    print LATEX "\\chapter{Liste alphab\\'etique des routines.}\n" ;
    print LATEX "On met le num\\'ero de ligne d'appel ou de d\\'efinition entre parenth\\`eses.\n" ;
    print LATEX "\\hfill\\\\\\noindent\n" ;
    print LATEX "\\begin{enumerate}\n" ;
    @liste=sort @main::routines ;
    while (@liste) {
	($Routine,$file,$href)=split(/:/,shift @liste);
	local($RoutineCasei) = main::GetLowerCase($Routine) ;
	local($latexRoutine) = main::LaTeXProtect($RoutineCasei);
	local($tag) = "R_$RoutineCasei";
	local($latexFile) = main::LaTeXProtect($file);
	print LATEX "%\\begin{$latexRoutine}\n" ;
	print LATEX "\\item {\\bf $latexRoutine}\\label{$tag} est d\\'eclar\\'ee dans {\\bf $latexFile}, ($main::L_Declar{$RoutineCasei}).\n" ;
	local($totalRoutine)=GetFullDeclare($RoutineCasei) ;
	print LATEX LATEX_Private_Called($totalRoutine,"source") ;
	print LATEX LATEX_Private_Calls($totalRoutine,"source") ;
	print LATEX Gere_Latex_Include($RoutineCasei,$latexRoutine,$file) ;
	if (exists $main::sons{"$totalRoutine"}) {
	    print LATEX "{\\bf $latexRoutine} defines private routines\n" ;
	    print LATEX "%%%%%%%%%%%%%%%%%%%%%%%\n";
	    print LATEX "\\begin{itemize}\n";
	    foreach $son (keys %{$main::sons{$totalRoutine}}) {
		local($privateRoutine) = ${$main::sons{$totalRoutine}}{$son} ;
	        print LATEX "\\item ";
	        print LATEX LATEX_Private_Called($privateRoutine,"source") ;
	        print LATEX LATEX_Private_Calls($privateRoutine,"source") ;
	    }
	    print LATEX "\\end{itemize}\n";
	    print LATEX "%%%%%%%%%%%%%%%%%%%%%%%\n";
        }
	print LATEX "\\end{itemize}\n" ;
	print LATEX "%\\end{$latexRoutine}\n" ;
    }
    print LATEX "\\end{enumerate}\n" ;
    }
    close (LATEX) ;
}
#|##############################
sub MakeCallsF90Html {
    local($source,$index,$tag,$localtag)=@_;
    local($htmlligne)="";
    local($latexligne)="";
    $ref = "".CodeName($fichier,"$source").".html#$tag";
    $htmlligne .= "<LI><A HREF=\"$ref\" ".Target("$source").index::OnClick("$file","$tag","$index").">$localReference</A>";
    $latexligne .= "\\item $latexReference [r\\'ef \\ref{$tag}, p. \\pageref{$tag}] line(s)\n";
    $numloc=1 ;
    foreach $num (@numlist) {
	if ($numloc) {
	    $numloc=0 ;
	} else {
	    $htmlligne .= " - ";
	    $latexligne .= ", ";
	}
	$htmlligne .= " (<A HREF=\"".CodeName($file,"$source").".html#$localtag$num\" ".Target("$source").index::OnClick("$file","$tag","$index").">$num</A>)\n";
	$latexligne .= " ($num)";
    }
    $latexligne .= ".\n";
    return($htmlligne,$latexligne);
}
#|##############################
sub Calling {
    local($source,$index,$ligne,$Routine,$LocalName,$putLabel)=@_;
    local($localRoutine,$localFile,$localNum)=main::GetInfoRoutine($Routine) ;
    local($tag,$lien) = ("C_$localRoutine","") ;
    if (($main::father{$Routine}) && ("$main::father{$Routine}" ne "$localFile:$localFile:0")) {
	$tag = "C_$localRoutine$localNum" ;
    }
    local($htmlFile) = CodeName($localFile,"$source").".html";
    local($cref) = "$htmlFile#$tag";
    if ($putLabel) {
	$lien .= "<A NAME=\"$tag\"></A>";
    }
    $lien = "<A Href=\"$cref\" ".Target("$source").index::OnClick("$localFile","$tag","$index").">$LocalName</A>";
    if (("$source" ne "") && ("$index" ne "") && ($putLabel)) {
	$lien .= " is declared in <A Href=\"$htmlFile\" ".Target("$source").index::OnClick("$localFile","","$index").">$localFile</A> line $localNum.";
    }
    $ligne =~ s/$LocalName/$lien/;
    return($ligne) ;
}
#%###################################################
sub Index_Private_Called {
    local($Routine,$source,$index)=@_;
    local($localRoutine,$fichier,$numDef)=GetInfoRoutine($Routine);
    local($latexRoutine) = LaTeXProtect($localRoutine);
    GetIncludeCibleOfWrite($fichier);
    $index = "" unless ($index);
    $source = "" unless $source ;
    local($htmlligne)="";
    local($latexligne)="";

    local($num)=0;
    local($ref)="";
    local($lochtmlligne,$loclatexligne) = ("","");
    local($uphtmlligne,$uplatexligne) = ("","");

    local(@liste_appels_complet)=();
    if (exists $realcalled{"$Routine"}) {
# Define a table on the calling routines of $nom
        $uphtmlligne .= "$localRoutine is called by\n";
        $uphtmlligne .= "<UL>\n";
	$uplatexligne .= "{\\bf $latexRoutine} is called by\n";
	$uplatexligne .= "\\begin{itemize}\n";
# Do note that a private routine cannot be called outside its scope !
	@liste_appels_complet = sort keys %{$realcalled{$Routine}};
	foreach $Reference (@liste_appels_complet) {
# The following should equal to first part of $Routine... unless
# it is an alias on it (with the local redeclaration on module use)
	    local($suspectcasei) = ${realcalled{$Routine}}{$Reference} ;
	    local($localReference,$file,$num)=GetInfoRoutine($Reference);
	    local($latexReference) = LaTeXProtect($localReference);
	    @numlist=();
#	    print "$nom is called by $Reference and is defined at $Routine\n";
	    if ("$father{$Routine}" eq "$fichier:$fichier:0") {
# Means the procedure that is called is a global one
		if ("$father{$Reference}" eq "$file:$file:0") {
		    $tag = "R_$localReference";
		} else {
		    $tag = "R_$localReference$num";
		}
		if ((defined(%{$Appelants{$localRoutine}})) && (${$Appelants{$localRoutine}}{$Reference})) {
		   (@numlist)=(sort numerique split(/ /, ${$Appelants{$localRoutine}}{$Reference})) ;
                }
	    } elsif ("$father{$Reference}" eq "$file:$file:0") {
# Means the procedure that is called is a global one
		$tag = "R_$localReference";
		(@numlist)=(@{${$effectcalled{$Reference}}{$suspectcasei}}) ;
	    } else {
# Means the procedure that is called is a private one
#		print "Private $localRoutine($fichier,$numDef) called by $Reference\n";
		$tag = "R_$localReference$num";
		(@numlist)=(@{${$effectcalled{$Reference}}{$suspectcasei}}) ;
	    }
            if (@numlist) {
                ($lochtmlligne,$loclatexligne) = (MakeCalledF90Html($source,$index,$tag,"C_$localReference")) ;
                $htmlligne .= $lochtmlligne ; $latexligne .= $loclatexligne ;
            }
        }
        if ($htmlligne) {
           $htmlligne .= "</UL>\n";
	   $htmlligne = $uphtmlligne.$htmlligne ;
	   $latexligne .= "\\end{itemize}\n";
	   $latexligne = $uplatexligne.$latexligne ;
       } else {
	   $htmlligne .= "$localRoutine is not called.\n";
	   $latexligne .= "{\\bf $latexRoutine} is not called.\n";
       }
    } else {
	$htmlligne .= "$localRoutine is not called.\n";
	$latexligne .= "{\\bf $latexRoutine} is not called.\n";
    }
    return($htmlligne,$latexligne);
}

#|#######################################################
sub MakeCalledF90Html {
    local($source,$index,$tag,$localtag)=@_;
    local($htmlligne)="";
    local($latexligne)="";
    $ref = "".CodeName($file,"$source").".html#$tag";
    $htmlligne .= "<LI><A HREF=\"$ref\" ".Target("$source").index::OnClick("$file","$tag","$index").">$localReference</A>";
    $latexligne .= "\\item $latexReference [r\\'ef \\ref{$tag}, p. \\pageref{$tag}] line(s)\n";
    $numloc=1 ;
    foreach $num (@numlist) {
	if ($numloc) {
	    $numloc=0 ;
	} else {
	    $htmlligne .= " - ";
	    $latexligne .= ", ";
	}
	$htmlligne .= " (<A HREF=\"".CodeName($file,"$source").".html#$localtag$num\" ".Target("$source").index::OnClick("$file","$tag","$index").">$num</A>)\n";
	$latexligne .= " ($num)";
    }
    $latexligne .= ".\n";
    return($htmlligne,$latexligne);
}

#|#######################################################
sub MakeCallsF90Html {
    local($source,$index,$tag,$localtag)=@_;
    local($htmlligne)="";
    local($latexligne)="";
    $ref = "".CodeName($fichier,"$source").".html#$tag";
    $htmlligne .= "<LI><A HREF=\"$ref\" ".Target("$source").index::OnClick("$file","$tag","$index").">$localReference</A>";
    $latexligne .= "\\item $latexReference [r\\'ef \\ref{$tag}, p. \\pageref{$tag}] line(s)\n";
    $numloc=1 ;
    foreach $num (@numlist) {
	if ($numloc) {
	    $numloc=0 ;
	} else {
	    $htmlligne .= " - ";
	    $latexligne .= ", ";
	}
	$htmlligne .= " (<A HREF=\"".CodeName($file,"$source").".html#$localtag$num\" ".Target("$source").index::OnClick("$file","$tag","$index").">$num</A>)\n";
	$latexligne .= " ($num)";
    }
    $latexligne .= ".\n";
    return($htmlligne,$latexligne);
}
#|#######################################################
sub Gere_Index_Includes {
    local($file,$Routine,$source,$index)=@_;
    $source = "" unless $source ;
    $index = "" unless $index;
    local($ligne)="";
    if ($fonctions_includes{$Routine}) {
	@liste_appels_complet = sort split(/ /, $fonctions_includes{$Routine});
	$nb_inclut = $#liste_appels_complet+1 ;
	if ( $nb_inclut > 1 ) {
	    $ligne .= " qui effectue $nb_inclut inclusions de fichiers:\n" ;
	} else {
	    $ligne .= " qui inclut $nb_inclut fichier:\n" ;
	}
	$ligne .= "<UL>\n";
	$prev_fichier = "" ;
	while (@liste_appels_complet) {
	    @liste_appels=split(/:/, shift @liste_appels_complet);
	    shift @liste_appels;
	    local($fichier)=shift @liste_appels;
	    local($num)=shift @liste_appels;
	    local($ref)=$fichier ;
	    &GetIncludeCibleOfWrite($ref) ;
	    if ($prev_fichier eq "") {
		if ($fichier_full_name=find_include($fichier)) {
		    &GetIncludeCibleOfWrite($fichier_full_name) ;
		    $ref=$fichier_full_name;
		    $ligne .= "<LI><A HREF=".CodeName($fichier_full_name,"$source").".html ".Target("$source").index::OnClick("$fichier_full_name","","$index").">$fichier</A>";
		} else {
		    $ligne .= "<LI><I><FONT COLOR=RED>$fichier</FONT></I>";
		}
		$ligne .= " (<A HREF=\"".CodeName($file,"$source").".html#I_$ref$num\" ".Target("$source").index::OnClick("$file","R_$Routine","$index").">$num</A>)";
	    } elsif($prev_fichier eq $fichier) {
		$ligne .= ", (<A HREF=\"".CodeName($file,"$source").".html#I_$ref$num\" ".Target("$source").index::OnClick("$file","R_$Routine","$index").">$num</A>)";
	    } else {
		if ($fichier_full_name=find_include($fichier)) {
		    &GetIncludeCibleOfWrite($fichier_full_name) ;
		    $ref=$fichier_full_name;
		    $ligne .= ",\n<LI><A HREF=".CodeName($fichier_full_name,"$source").".html ".Target("$source").index::OnClick("$fichier_full_name","","$index").">$fichier</A>";
		} else {
		    $ligne .= "\n<LI><I><FONT COLOR=RED>$fichier</FONT></I>";
		}
		$ligne .= " (<A HREF=\"".CodeName($file,"$source").".html#I_$ref$num\" ".Target("$source").index::OnClick("$file","R_$Routine","$index").">$num</A>)";
	    }
	    $prev_fichier = $fichier ;
	}
	$ligne .= ".\n</UL>";
    }
    return ($ligne);
}

#|#######################################################
sub GetFullDeclare {
    local($NOM) = @_ ;
    $NOM = main::GetLowerCase($NOM);
    $NOM = "$NOM:".$main::File_Of_Rout{$NOM}.":".$main::L_Declar{$NOM};
    return($NOM) ;
}
#|##############################
sub Old_Declare {
# is equivalent to F90_html_declare
    my($putLabel) = @_ ;
    my($lien,$cref) = ("","","") ;
    $lien = "{\\bf $latexRoutine}";
    $cref = $tag;
    if ($putLabel) {
	$lien .= "\\label{$cref} is declared in {\\bf $latexFile}, ($localNum).";
    }
    $ligne =~ s/$LocalName/$lien/;
    return("$ligne") ;
}
#|##############################
sub OldDeclare {
# is equivalent to F90_html_declare
    local($source,$index,$ligne,$Routine,$LocalName,$putLabel)=@_;
    local($localRoutine,$localFile,$localNum)=main::GetInfoRoutine($Routine) ;
    local($latexFile) = LaTeXProtect($localFile);
    local($latexRoutine) = LaTeXProtect($localRoutine);
    local($cref,$lien) = ("R_$localRoutine","") ;
#    if (($main::father{$Routine}) && ("$main::father{$Routine}" ne "$localFile:$localFile:0")) {
    if (($main::father{$Routine}) && (main::IsFatherNotTop("$main::father{$Routine}") > 0)) {
	$cref = "R_$localRoutine$localNum" ;
    }
    $lien = "{\\bf $latexRoutine}";
    if ($putLabel) {
	$lien .= "\\label{$cref} is declared in {\\bf $latexFile}, ($localNum).";
    }
    $ligne =~ s/$LocalName/$lien/;
    return("$ligne") ;
}
#|##############################
sub OldDeclareRef {
    local($source,$index,$ligne,$Routine,$LocalName,$putLabel)=@_;
    local($localRoutine,$localFile,$localNum)=main::GetInfoRoutine($Routine) ;
    local($latexFile) = LaTeXProtect($localFile);
    local($remoteFile) = LaTeXProtect($putLabel);
    local($latexRoutine) = LaTeXProtect($localRoutine);
    local($cref,$lien) = ("R_$localRoutine","") ;
    if (($main::father{$Routine}) && (main::IsFatherNotTop("$main::father{$Routine}") > 0)) {
	$cref = "R_$localRoutine$localNum" ;
    }
    $lien .= "{\\bf $latexRoutine} [r\\'ef \\ref{$cref}, p. \\pageref{$cref}] line(s)";
    $ligne =~ s/$LocalName/$lien/;
    return("$ligne") ;
}
#|##############################
# This routine is not used.
sub HtmlDeclare {
    local($source,$index,$ligne,$Routine,$LocalName,$putLabel)=@_;
    local($localRoutine,$localFile,$localNum)=main::GetInfoRoutine($Routine) ;
    local($tag,$lien,$htmlFile) = ("R_$localRoutine","","") ;
    if (($main::father{$Routine}) && (main::IsFatherNotTop("$main::father{$Routine}") > 0)) {
	$tag = "R_$localRoutine$localNum" ;
    }
    if ($putLabel == 1) {
	$htmlFile = CodeName($localFile,"$source").".html";
	$lien .= "<A NAME=\"$tag\"></A>";
    } elsif ($putLabel == 0) {
	$htmlFile = CodeName($localFile,"$source").".html";
    } else {
	$htmlFile = CodeName($putLabel,"$source").".html";
    }
    local($cref) = "$htmlFile#$tag";
    $lien = "<A Href=\"$cref\" ".Target("$source").index::OnClick("$localFile","$tag","$index").">$LocalName</A>";
    if (("$source" ne "") && ("$index" ne "") && ($putLabel == 1)) {
	$lien .= " is declared in <A Href=\"$htmlFile\" ".Target("$source").index::OnClick("$localFile","","$index").">$localFile</A> line $localNum.";
    }
    $ligne =~ s/$LocalName/$lien/;
    return($ligne) ;
}
#|#######################################################
sub OldIndex_Fonctions {
# index des fonctions
    open(MAINFRAME,">$main::DIRE/foncindex.html");
    print MAINFRAME OpenMainFrame("index","foncindex_c","Index des fonctions de $main::RepCodeSource");
    close(MAINFRAME);
    open(INDEX,">$main::DIRE/foncindex_c.html");
    print INDEX OpenIndex("Index des fonctions de $main::RepCodeSource");
    print INDEX main::En_Tete_All("","none","source");

    (@liste)=(sort @main::functions) ;
    if (@liste) {
	print INDEX "<H3>Liste alphabtique des fonctions (numro de ligne) : </H3><OL>\n";
	&FunSubIndex ;
    } else {
	print INDEX "<H3>Pas de fonction dclare dans $main::RepCodeSource.</H3><OL>\n";
    }
    &Index_Ferme;
} ;
#|#######################################################
sub OldIndex_Routines {
# index des routines
    open(MAINFRAME,">$main::DIRE/routindex.html");
    print MAINFRAME OpenMainFrame("index","routindex_c","Index des subroutines de $main::RepCodeSource");
    close(MAINFRAME);
# index code.
    open(INDEX,">$main::DIRE/routindex_c.html");
    print INDEX OpenIndex("Index des subroutines de $main::RepCodeSource");
    print INDEX main::En_Tete_All("","none","source");
    (@liste)=(sort @main::routines) ;
    if (@liste) {
	print INDEX "<H3>Liste alphabtique des subroutines (numro de ligne) : </H3><OL>\n";
	&FunSubIndex ;
    } else {
	print INDEX "<H3>Pas de subroutine fortran dans $main::RepCodeSource.</H3><OL>\n";
    }
    &Index_Ferme;
} ;
#|#######################################################
sub OldIndex_Principal {
# index principal
    $lang = "html";
    (%affiche)=(main::TalkInLaTeXOrHtml($lang,%main::delegue));
    &Index_Index;
    open(MAINFRAME,">$main::DIRE/progindex.html");
    print MAINFRAME OpenMainFrame("index","progindex_c","Index des programmes de $main::RepCodeSource");
    close(MAINFRAME);
# index code.
    open(INDEX,">$main::DIRE/progindex_c.html");
    print INDEX OpenIndex("Index des programmes de $main::RepCodeSource");
    print INDEX main::En_Tete_All("","none","source");
    (@liste)=(sort @main::programmes);
    $Main_Point_Href = "fileindex_c.html";
    $Main_Point_Name = "fileindex_c";
    while(@liste) {
	($Routine,$file,$href)=split(/:/,shift @liste);
	$nom = $Routine ;
	$NOM = $nom ;
	$NOM =~ tr/A-Z/a-z/ ;
	$Main_Point_Href = "$file"."_c.html#R_$Routine";
	$Main_Point_Name = "$file";
	print INDEX "<P><A NAME=$nom><LI></A>\n";
	print INDEX "Le programme ";
	print INDEX "<A HREF=\"${file}_c.html#R_$Routine\" TARGET=\"source\"".OnClick("$file","R_$Routine","index").">".$nom."</A>";
	print INDEX " est dclar dans <A HREF=\"${file}_c.html\" TARGET=\"source\"".OnClick("$file","","index").">".$file."</A> ";
	print INDEX "ligne $main::L_Declar{$nom}.<BR>\n";
	&Gere_Index ;
    }
    &Index_Ferme;
} ;
#|#######################################################
sub FunSubIndex {
    while (@liste) {
	($Routine,$file,$href)=split(/:/,shift @liste);
	$nom = $Routine ;
	$NOM = $nom ;
	$NOM =~ tr/A-Z/a-z/ ;
	print INDEX "<P><A NAME=$nom><LI></A>\n";
	print INDEX "<A HREF=\"${file}_c.html#R_$Routine\" TARGET=\"source\"".OnClick("$file","R_$Routine","index").">".$nom."</A>";
	print INDEX " est dclare dans <A HREF=\"${file}_c.html\" TARGET=\"source\"".OnClick("$file","","index").">".$file."</A> ";
	print INDEX "ligne $main::L_Declar{$nom}\n";
	&Gere_Index ;
    }
}
#|#######################################################
sub OldManage_Index_Include {
    local($nom,$source,$index)=@_;
    $index = "" unless ($index);
    local($target)="";
    local($fileext)="";
    if (($source) && ("$source" ne "")) {
	$target=" TARGET=\"$source\"";
	$fileext="_c";
    }
    local($ligne)="";
    $file_loc = FileName($nom) ;
    $filebis = $nom ;
    &GetIncludeCibleOfWrite($filebis) ;
    if ($fichier_full_name=main::find_include($nom)) {
	&GetIncludeCibleOfWrite($fichier_full_name) ;
	$filebis=$fichier_full_name.$fileext ;
	$file_bis=$fichier_full_name;
	$ligne .= "<A NAME=$filebis></A><A NAME=$file_loc></A>";
	$ligne .= " <A HREF=\"".main::CodeName($fichier_full_name,"$source").".html\" ".main::Target("$source").OnClick("$file_bis","","$index").">$nom</A>\n";
    } else {
	$ligne .= "<A NAME=$file_loc><I><FONT COLOR=RED>$nom</FONT></I>\n" ;
    }
    $ligne .= "demand par:\n" ;
    @liste_appels=split(/:/, $main::appels_de_includes{$nom});
    shift @liste_appels;
    $ligne .= "<UL>\n";
    $prev_fichier = "" ;
    while (@liste_appels) {
	local($RoutEncour)=shift @liste_appels ;
	local($num)=shift @liste_appels ;
	local($fichier)=$main::File_Of_Rout{$RoutEncour} ;
	local($ref)=$fichier ;
	&GetIncludeCibleOfWrite($ref) ;
	if ($prev_fichier eq $RoutEncour) {
	    $ligne .= ", (<A HREF=\"".main::CodeName($ref,"$source").".html#I_$file_bis$num\" ".main::Target("$source").OnClick("$ref","R_$RoutEncour","$index").">$num</A>)";
	} elsif ($prev_fichier eq "") {
	    if ( $fichier eq $RoutEncour ) {
		$ligne .= "<LI><A HREF=\"".main::CodeName($ref,"$source").".html\" ".main::Target("$source").OnClick("$ref","","$index").">$RoutEncour</A>";
		$ligne .= " (<A HREF=\"".main::CodeName($ref,"$source").".html#I_$file_bis$num\" ".main::Target("$source").OnClick("$ref","R_$RoutEncour","$index").">$num</A>)";
	    } else {
		$ligne .= "<LI><A HREF=\"".main::CodeName($ref,"$source").".html#R_$RoutEncour\" ".main::Target("$source").OnClick("$ref","R_$RoutEncour","$index").">$RoutEncour</A>";
		$ligne .= " (<A HREF=\"".main::CodeName($ref,"$source").".html#I_$file_bis$num\" ".main::Target("$source").OnClick("$ref","R_$RoutEncour","$index").">$num</A>)";
	    }
	} else {
	    if ( $fichier eq $RoutEncour ) {
		$ligne .= ".\n <LI><A HREF=\"".main::CodeName($ref,"$source").".html\" ".main::Target("$source").OnClick("$ref","","$index").">$RoutEncour</A>";
		$ligne .= " (<A HREF=\"".main::CodeName($ref,"$source").".html#I_$file_bis$num\" ".main::Target("$source").OnClick("$ref","R_$RoutEncour","$index").">$num</A>)";
	    } else {
		$ligne .= ".\n <LI><A HREF=\"".main::CodeName($ref,"$source").".html#R_$RoutEncour\" ".main::Target("$source").OnClick("$ref","R_$RoutEncour","$index").">$RoutEncour</A>";
		$ligne .= " (<A HREF=\"".main::CodeName($ref,"$source").".html#I_$file_bis$num\" ".main::Target("$source").OnClick("$ref","R_$RoutEncour","$index").">$num</A>)";
	    }
	}
	$prev_fichier = $RoutEncour ;
    }
    $ligne .= ".\n</UL>\n";
    return($ligne);
}
#|#######################################################
sub Old_Index_Fichiers {
    local(@liste)=(sort @_) ;
# index des fichiers
    open(MAINFRAME,">$main::DIRE/fileindex.html");
    print MAINFRAME OpenMainFrame("index","fileindex_c","Index des fichiers de $main::RepCodeSource");
    close(MAINFRAME);
    open(INDEX,">$main::DIRE/fileindex_c.html");
    print INDEX OpenIndex("Index des fichiers de $main::RepCodeSource");
    print INDEX main::En_Tete_All("","none","source");
    local($source,$index)=("source","index");
    foreach $file (@liste) {
	$file_ter = $main::File_Of_Rout{$file};
	if ($main::NBL{$file}) {
	    $file_ter = $main::File_Of_Rout{$file};
	    $filebis = $file ;
	    $file_loc = FileName($file) ;
	    &GetIncludeCibleOfWrite($filebis) ;
	    if ($main::fichier_to_Routine{$file}) {
		(@liste_def) = sort split(/:/, $main::fichier_to_Routine{$file}) ;
		$nb_def = $#liste_def+1 ;
		print INDEX "<P><A NAME=$filebis><LI></A><A NAME=$file_loc>";
		print INDEX "</A><A HREF=\"".main::CodeName($filebis,"$source").".html\" ".main::Target("$source").OnClick("$filebis","","$index").">$file</A>:";
		if ( $nb_def > 1 ) {
		    print INDEX " ($main::NBL{$file}) dfinit $nb_def sous-programmes:\n";
		} else {
		    print INDEX " ($main::NBL{$file}) dfinit $nb_def sous-programme:\n";
		}
		print INDEX "<UL>\n";
		foreach $Routine (@liste_def) {
		    if ( $main::L_Declar{$Routine} ) {
			print INDEX "<LI>" if ($nb_def > 1) ;
			print INDEX "<A HREF=\"".main::CodeName($filebis,"$source").".html#R_$Routine\" ".main::Target("$source").OnClick("$filebis","R_$Routine","$index").">$Routine</A> ($main::L_Declar{$Routine})\n";
		    } else {
			print INDEX "<LI>" if ($nb_def > 1) ;
			print INDEX "<A HREF=\"".main::CodeName($filebis,"$source").".html#R_$Routine\" ".main::Target("$source").OnClick("$filebis","R_$Routine","$index").">$Routine</A> (1)\n";
			print "Unexpected $filebis for $Routine\n";
		    }
		    $ligne=(main::Gere_Index_Includes($file,$Routine,"source","index")) ;
		    print INDEX "$ligne\n";
		}
		print INDEX "</UL>\n";
		if ($main::fonctions_includes{$file}) {
		    print INDEX "Le fichier <A HREF=\"".main::CodeName($filebis,"$source").".html\" ".main::Target("$source").OnClick("$filebis","","$index").">$file</A> utilise en global:\n" ;
		}
	    } else {
		print INDEX "<P><A NAME=$filebis><LI></A>";
		print INDEX "<A HREF=\"".main::CodeName($filebis,"$source").".html\" ".main::Target("$source").OnClick("$filebis","","$index").">$file</A>:";
		print INDEX " ($main::NBL{$file}) ne dfinit aucun sous-programme,";
		if ($main::fonctions_includes{$file}) {
		    print INDEX "mais utilise:\n" ;
		} else {
		    print INDEX "et n'utilise aucun fichier 'include'.\n" ;
		}
	    }
	    if ($main::fonctions_includes{$file}) {
		$ligne=(main::Gere_Index_Includes($file,$file,"$source","$index")) ;
		print INDEX "$ligne\n";
	    } elsif (0) {
		@liste_appels_complet = sort split(/ /, $main::fonctions_includes{$file});
		print INDEX "<UL>\n";
		$prev_fichier = "" ;
		while (@liste_appels_complet) {
		    @liste_appels=split(/:/, shift @liste_appels_complet);
		    shift @liste_appels;
		    local($fichier)=shift @liste_appels;
		    local($ref)=$fichier;
		    local($num)=shift @liste_appels;
		    &GetIncludeCibleOfWrite($ref) ;
		    if ($fichier_full_name=main::find_include($fichier)) {
			&GetIncludeCibleOfWrite($fichier_full_name) ;
			$ref=$fichier_full_name ;
		    }
		    if ($prev_fichier eq "") {
			print INDEX "<LI>";
			print INDEX "<A HREF=$ref.html>$fichier</A> ";
			print INDEX "(<A HREF=$filebis.html#I_$ref$num>$num</A>)";
		    }  elsif($prev_fichier eq $fichier) {
			print INDEX ", (<A HREF=$filebis.html#I_$ref$num>$num</A>)";
		    } else {
			print INDEX ",\n<LI>";
			print INDEX "<A HREF=$ref.html>$fichier</A>";
			print INDEX " (<A HREF=$filebis.html#I_$ref$num>$num</A>)";
		    }
		    $prev_fichier = $fichier ;
		}
		print INDEX ".\n</UL>\n";
	    }
	} else {
	    print INDEX "<P><I>$file</I> n'est pas utilis. ";
	    print INDEX "<A HREF=$DIRC/$file>Source original</A>\n";
	}
    }
    &Index_Ferme;
} ;
#|#######################################################
sub Old_Manage_Index_Input {
# index des input
    local($nom,$cible,$source,$index)=@_;
    $index = "" unless ($index);
    local($target)="";
    if (($source) && ("$source" ne "")) {
	$target=" TARGET=\"$source\"";
    }
    $source = "" unless $source ;
    local($ligne)="";
    $ref="$nom.html#I_$nom";
    $ref="$nom#I_$nom";
#	$ref="$main::INPUTNOM/$cible.html";
    $ref="$cible";
    (@tata) = split ( /\//, $nom) ;
    (@Var) = split ( /\./, $tata[$#tata]) ;
    $Variable = $Var[0] ;
    $main::file=$nom ;
    $file_loc = FileName($nom) ;
    $ligne .= "<A NAME=$cible></A><A NAME=$file_loc></A>";
    $ligne .= "<A HREF=\"".main::CodeName($ref,"$source").".html\" ".main::Target("$source").OnClick("$ref","","$index").">$Variable</A> ";
    $ligne .= " est demand par:\n";
    @liste_appels=split(/:/, $main::appels_de_input{$nom});
    shift @liste_appels;
    $ligne .= "<UL>\n";
    while (@liste_appels) {
	$fichier=shift @liste_appels ;
	$num=shift @liste_appels ;
	$RoutEncour=shift @liste_appels ;
	$ligne .= "<LI>";
	$ligne .= "<A HREF=\"".main::CodeName($fichier,"$source").".html#R_$RoutEncour\" ".main::Target("$source").OnClick("$fichier","R_$RoutEncour","$index").">$RoutEncour</A>\n";
	$ligne .= " <A HREF=\"".main::CodeName($fichier,"$source").".html#I_$nom$num\" ".main::Target("$source").OnClick("$fichier","R_$RoutEncour","$index").">($num)</A>\n";
    }
    $ligne .= "</UL>\n";
    return($ligne);
} ;
#|#######################################################
sub Gere_Index_Includes {
    local($file,$Routine,$source,$index)=@_;
    $source = "" unless $source ;
    $index = "" unless $index;
    local($ligne)="";
    if ($fonctions_includes{$Routine}) {
	@liste_appels_complet = sort split(/ /, $fonctions_includes{$Routine});
	$nb_inclut = $#liste_appels_complet+1 ;
	if ( $nb_inclut > 1 ) {
	    $ligne .= " qui effectue $nb_inclut inclusions de fichiers:\n" ;
	} else {
	    $ligne .= " qui inclut $nb_inclut fichier:\n" ;
	}
	$ligne .= "<UL>\n";
	$prev_fichier = "" ;
	while (@liste_appels_complet) {
	    @liste_appels=split(/:/, shift @liste_appels_complet);
	    shift @liste_appels;
	    local($fichier)=shift @liste_appels;
	    local($num)=shift @liste_appels;
	    local($ref)=$fichier ;
	    &GetIncludeCibleOfWrite($ref) ;
	    if ($prev_fichier eq "") {
		if ($fichier_full_name=find_include($fichier)) {
		    &GetIncludeCibleOfWrite($fichier_full_name) ;
		    $ref=$fichier_full_name;
		    $ligne .= "<LI><A HREF=".CodeName($fichier_full_name,"$source").".html ".Target("$source").index::OnClick("$fichier_full_name","","$index").">$fichier</A>";
		} else {
		    $ligne .= "<LI><I><FONT COLOR=RED>$fichier</FONT></I>";
		}
		$ligne .= " (<A HREF=\"".CodeName($file,"$source").".html#I_$ref$num\" ".Target("$source").index::OnClick("$file","R_$Routine","$index").">$num</A>)";
	    } elsif($prev_fichier eq $fichier) {
		$ligne .= ", (<A HREF=\"".CodeName($file,"$source").".html#I_$ref$num\" ".Target("$source").index::OnClick("$file","R_$Routine","$index").">$num</A>)";
	    } else {
		if ($fichier_full_name=find_include($fichier)) {
		    &GetIncludeCibleOfWrite($fichier_full_name) ;
		    $ref=$fichier_full_name;
		    $ligne .= ",\n<LI><A HREF=".CodeName($fichier_full_name,"$source").".html ".Target("$source").index::OnClick("$fichier_full_name","","$index").">$fichier</A>";
		} else {
		    $ligne .= "\n<LI><I><FONT COLOR=RED>$fichier</FONT></I>";
		}
		$ligne .= " (<A HREF=\"".CodeName($file,"$source").".html#I_$ref$num\" ".Target("$source").index::OnClick("$file","R_$Routine","$index").">$num</A>)";
	    }
	    $prev_fichier = $fichier ;
	}
	$ligne .= ".\n</UL>";
    }
    return ($ligne);
}

#|#######################################################
sub MakeCalledF90Html {
    local($source,$index,$tag,$localtag)=@_;
    local($htmlligne)="";
    local($latexligne)="";
    $ref = "".CodeName($file,"$source").".html#$tag";
    $htmlligne .= "<LI><A HREF=\"$ref\" ".Target("$source").index::OnClick("$file","$tag","$index").">$localReference</A>";
    $latexligne .= "\\item $latexReference [r\\'ef \\ref{$tag}, p. \\pageref{$tag}] line(s)\n";
    $numloc=1 ;
    foreach $num (@numlist) {
	if ($numloc) {
	    $numloc=0 ;
	} else {
	    $htmlligne .= " - ";
	    $latexligne .= ", ";
	}
	$htmlligne .= " (<A HREF=\"".CodeName($file,"$source").".html#$localtag$num\" ".Target("$source").index::OnClick("$file","$tag","$index").">$num</A>)\n";
	$latexligne .= " ($num)";
    }
    $latexligne .= ".\n";
    return($htmlligne,$latexligne);
}

#|#######################################################
sub MakeCallsF90Html {
    local($source,$index,$tag,$localtag)=@_;
    local($htmlligne)="";
    local($latexligne)="";
    $ref = "".CodeName($fichier,"$source").".html#$tag";
    $htmlligne .= "<LI><A HREF=\"$ref\" ".Target("$source").index::OnClick("$file","$tag","$index").">$localReference</A>";
    $latexligne .= "\\item $latexReference [r\\'ef \\ref{$tag}, p. \\pageref{$tag}] line(s)\n";
    $numloc=1 ;
    foreach $num (@numlist) {
	if ($numloc) {
	    $numloc=0 ;
	} else {
	    $htmlligne .= " - ";
	    $latexligne .= ", ";
	}
	$htmlligne .= " (<A HREF=\"".CodeName($file,"$source").".html#$localtag$num\" ".Target("$source").index::OnClick("$file","$tag","$index").">$num</A>)\n";
	$latexligne .= " ($num)";
    }
    $latexligne .= ".\n";
    return($htmlligne,$latexligne);
}

#|#######################################################
sub Include_F90_Detect {
    local($file,$Routine,$num,$fichier)=@_;
    if (0) {
#    if (($father{$Routine}) && (IsFatherNotTop("$father{$Routine}"))) {
        ($localRoutine,$localFile,$localNum)=GetInfoRoutine($Routine);
#	print "Include $fichier called at line $num in $Routine file $file\n";
	if ($appels_de_includes{$fichier}) {
	    $appels_de_includes{$fichier} .=":$localRoutine:$num";
	} else {
	    push(@includes,$fichier);
	    $appels_de_includes{$fichier} = ":$localRoutine:$num";
	    if($include=find_include($fichier)) {
		push(@listebis,$include);
	    } else {
		push(@liste_exclu,$fichier);
	    }
	}
	if ($fonctions_includes{$localRoutine}) {
	    $fonctions_includes{$localRoutine} .=" :$fichier:$num" ;
	} else {
	    $fonctions_includes{$localRoutine} =":$fichier:$num" ;
	}
    }
    local($totalFichier) = "" ;
    if($include=find_include($fichier)) {
#	print "Recherche du chemin absolu de $DIRC  $include\n";
# $include is a unique file name since it is absolute.
# Any included file that finds its unique name in $include
# is the same.
	$include = CheminAbsoluDeAaB("$DIRC",$include) ;
#	print "\t\t$include\n";
	if (exists $Include_Unique{"$include"}) {
	    $fichier = $Include_Unique{"$include"} ; # FIFO: a way to make fichier unique as well.
	} else {
	    $Include_Unique{"$include"} = $fichier ;
	    push(@listebis,$include); # This is a new file to add
	    $File_Of_Rout{$fichier} = $include ;
#	    print "Recherche du chemin relatif de $DIRE  $include\n";
	    local($fic) = CheminRelatifDeAaB("$DIRE",dirname($include)) ;
	    if ($fic) {
		$fic .= '/'.basename($include) ;
	    } else {
		$fic = basename($include) ;
	    }
#	    print "\t\t$fichier donne $File_Of_Rout{$fichier}\n";
	}
	$totalFichier = "$fichier:$include:0";
    } else {
	$totalFichier = "$fichier:0:0";
	push(@liste_exclu,$fichier);
	print "exclude $fichier\n";
    }
    push(@{$f90included{$totalFichier}{$Routine}},$num) ;
    push(@{$f90includes{$Routine}{$totalFichier}},$num) ;
}
#|#######################################################
sub GetCalls_F90 {
# Anlysis of the program's definitions with their father and their sons.
    print "\tDtection des appels du fortran 90.\n\t";
    local(@listerest)=(@_);
    foreach $file (@listerest) {
	$Compteur_local=Etat_Avancement($Compteur_local,$#listerest);
	open(FILE,"<$file") or die "Impossible to read file $file \n";
	if (exists $Include_Unique{$file}) {
	    $file_ref = $File_Of_Rout{$Include_Unique{$file}};
	    $Routine=GetTotalInclude($file);
	} else {
	    $file_ref = $File_Of_Rout{$file};
	    $Routine=GetTotalRoutine($file);
	}
	local($string) = "";
	local($instruction,$commentaire) = ("","");
	$father{$Routine} = $Routine ;
	local($interface) = 0 ;
	local($contains) = 0 ;
	local($use) = "" ;
	while ($ligne = <FILE>) {
	    chop($ligne) ;
	    ($string,$instruction,$commentaire) = searchfc::Fortran90_String_Comment($string,$ligne);
# I believe we already analyzed the comment segment of the line
# through updating hash %input_link and %label
#	    if ($commentaire) {
	    if (0) {
		if ($commentaire =~ /.*\\input\s+([\w_\.\/]+)/) {
		    $input_link{$1}=Input_Detect($file,$Routine,$.,$1);
		}
		LabelDeclare($file_ref,$commentaire) ;
	    }
	    if (($instruction) && ("$instruction" ne "")) {
		if ($instruction =~ /include\s+([\w_\.\/]+)/i) {
# Add the include's interfaces to the possible call list of $Routine
		    $fichier=$1 ;
		    if (defined($File_Of_Rout{$fichier})) {
			$include=$File_Of_Rout{$fichier} ;
			$globalinclude = "$Include_Unique{$include}:$include:0";
			foreach $son (keys %{$sons{$globalinclude}}) {
			    ${$available{$Routine}}{$son} = ${$sons{$globalinclude}}{$son} ;
		        }
		    } else {
			warn "$include no exist in File_Of_Rout";
		    }
		}
	        $instruction = GetLowerCase($instruction) ;
		if ($instruction =~ /^\s*use\s+([\w_\.\/]+)(.*)/i) {
		    $use = $1 ;
		    $instruction = $2 ;
		    $onlymodule = 0 ;
		    $lineuse = $. ;
		} elsif ($instruction =~ /end\s+(function|subroutine|program|module)\s+([\w_\.\/]+)/i) {
		    unless ($interface) {
			$Routine = "$father{$Routine}" ;
		    }
		} elsif ($instruction =~ /\s*(function|subroutine|program|module)\s+([\w_\.\/]+)/i) {
		    $LocalName = $2 ;
		    $Type = GetLowerCase($1) ;
		    unless ($interface) {
			$father{"$LocalName:$file:$."} = "$Routine" ;
			$Routine = "$LocalName:$file:$." ;
# We assume declarations starth here.
# We initialize our routine's available calls.
			%{$available{$Routine}} = () ;
# We add the sons of routines to its possible calls.
			foreach $son (keys %{$sons{$Routine}}) {
#			    print "Adding $son to $Routine\n";
			    ${$available{$Routine}}{$son} = ${$sons{$Routine}}{$son} ;
		        }
		    }
		} elsif ($instruction =~ /end\s+(interface)/i) {
		    $interface = $interface - 1 ;
		} elsif ($instruction =~ /^\s*(interface)(.*)/i) {
		    $interface = $interface + 1 ;
		    $instruction = $2 ;
		    if (($instruction) && ($instruction =~ /^\s+([\w_\.\/]+)/)) {
			$localinterface = $1 ;
			unless ($localinterface =~ /\b(subroutine|function)\b/i) {
# Ceci dfinit une nouvelle interface que l'on peut considrer comme
# une routine appelable directement.
# Tout ce qui suivra cette dfinition d'interface sera considr comme
# un appel.
# Attention, ceci ne sera pas le cas lorque l'interface n'aura pas de nom.
# Add the interface to the possible call list of $Routine
			    if ($interface == 1) {
# Well, we shall not analyse routines accrording to their
# protocoles, we prefer to analyse them at their specific declaration.
# Maybe I missed a point of fortran 90...
				$father{"$localinterface:$file:$."} = $Routine ;
# Seems to me the possible interfaces are known at that level
#				${$available{$Routine}}{$localinterface} = "$localinterface:$file:$." ;
			     }
			    
			}
		    }
		} elsif ($instruction =~ /^\s*(contains)/i) {
		    $contains = $contains + 1 ;
		} elsif (!$interface) {
#		    print "i($file:$.)=$instruction\n";
		    &Call_F90_Detect($Routine,$instruction) ;
		}
		if ($use) {
		    $enduse=Use_Analysis($use,$instruction) ;
		    if ((!$enduse)&&($File_Of_Rout{"$use"})) {
# It's time to update the list of available functions, routines and interfaces
# to routine $Routine
			$globaluse = "$use:".$File_Of_Rout{"$use"}.":".$L_Declar{"$use"};
			push(@{${realuses{$Routine}}{$globaluse}},$lineuse) ;
		        push(@{${realused{$globaluse}}{$Routine}},$lineuse) ;
			if ($onlymodule) {
# Il faut analyser le pointeur rename
#			    print "ONLY: module $use called by $Routine line $. file $file\n";
# We add a pointer to the list of use'rs...

			    foreach $realson (keys %{$rename{$Routine}}) {
				$son = ${$rename{$Routine}}{$realson} ;
			        ${$available{$Routine}}{$son} = ${$sons{$globaluse}}{$realson} ;
#				print "Mod1 $use: Adding alias $son to $globaluse, making $realson avail to $Routine line $. file $file\n";
		            }
			} else {
# Let'us review all the modules level one routines, taking care they could be renamed.
			    foreach $realson (keys %{$sons{$globaluse}}) {
				$son = $realson ;
				$son = ${$rename{$Routine}}{$realson} if ${$rename{$Routine}}{$realson} ;
#				print "Mod0 $use: Adding alias $son or real $realson to $globaluse, making $realson avail to $Routine line $. file $file\n";
				${$available{$Routine}}{$son} = ${$sons{$globaluse}}{$realson} ;
	                    }
                        }			
			$use="";
		    }
		}
	    }
	}
	close(FILE) ;
    }
    print "\n";
}
#|#######################################################
sub GetTagsAndInclude_F90 {
# Anlysis of the program's definitions with their father and their sons.
# It is not clear where to put the include's analysis: at this current
# level or below as for fortran 77 and C...
# Will have to be fixed.
    print "\tDtection des includes, inputs et labels du fortran 90.\n\t";
    local(@listerest)=(@_);
    foreach $file (@listerest) {
	$File_Of_Rout{$file} = $file ;
    }
    while (@listerest) {
	local(@listebis)=();
	print "|";
	$Compteur_local=0;
	foreach $file (@listerest) {
	    $Compteur_local=Etat_Avancement($Compteur_local,$#listerest);
	    open(FILE,"<$file") or die "Imossible to read file $file \n";
	    if (exists $Include_Unique{$file}) {
		$file_ref = $File_Of_Rout{$Include_Unique{$file}};
		$Routine=GetTotalInclude($file);
	    } else {
		$file_ref = $File_Of_Rout{$file};
		$Routine=GetTotalRoutine($file);
	    }
	    local($string) = "";
	    local($instruction,$commentaire) = ("","");
	    $father{$Routine} = $Routine ;
	    local($interface) = 0 ;
	    local($contains) = 0 ;
	    local($use) = "" ;
	    while ($ligne = <FILE>) {
		chop($ligne);
		($string,$instruction,$commentaire) = searchfc::Fortran90_String_Comment($string,$ligne);
		if ($commentaire) {
		    if ($commentaire =~ /.*\\input\s+([\w_\.\/]+)/) {
			$input_link{$1}=Input_Detect($file,$Routine,$.,$1);
		    }
		    LabelDeclare($file_ref,$commentaire) ;
		}
		if (($instruction) &&("$instruction" ne "")) {
		    if ($instruction =~ /include\s+([\w_\.\/]+)/i) {
			&Include_F90_Detect($file,$Routine,$.,$1);
		    }
		    $instruction = GetLowerCase($instruction) ;
		    if ($instruction =~ /end\s+(function|subroutine|program|module)\s+([\w_\.\/]+)/i) {
			unless ($interface) {
			    $Routine = "$father{$Routine}" ;
			}
		    } elsif ($instruction =~ /\s*(function|subroutine|program|module)\s+([\w_\.\/]+)/i) {
			$Type = $1 ;
			$LocalName = $2 ;
			$LocalNameCasei = GetLowerCase($LocalName) ;
			unless ($interface) {
			    $father{"$LocalNameCasei:$file:$."} = "$Routine" ;
			    $Routine = "$LocalNameCasei:$file:$." ;
			    if (!IsFatherNotTop($father{"$Routine"})) {
# On construit des table d'index pour les donnes globales:
# modules, subroutines, programs et functions accessibles pour tous
				$L_Declar{$LocalNameCasei}=$. ;
				$R_Declar{$LocalNameCasei}=$LocalNameCasei ;
				$label{"$LocalNameCasei"}="$file.html#R_$LocalNameCasei";
				$File_Of_Rout{$LocalNameCasei} = "$file" ;
				&Set_Detect($Type,$Routine,$file);
			    } else {
# Le point de dfinition est a priori priv: on dfinit
# la liste des fils du pre comme un tableau.
				$pere = $father{"$Routine"} ;
#				push(@{$sons{"$pere"}},"$Routine") ;
				($localname,$localFile,$localnum) = GetInfoRoutine($Routine);
				$label{"$localname#$localnum"}="$file.html#R_$localname$localnum";
				print "fils($pere){$localname}=$Routine\n" if $debug;
				${$sons{"$pere"}}{$localname} = "$Routine" ;
			    }
			}
		    }
		    if ($instruction =~ /end\s+(interface)/i) {
			$interface = $interface - 1 ;
			print "interface level downgrades to $interface line $.\n" if $debug;
		    } elsif ($instruction =~ /^\s*(interface)(.*)/i) {
			$interface = $interface + 1 ;
			print "interface level upgrades to $interface line $. \n" if $debug;;
			$instruction = $2 ;
			if (($instruction) && ($instruction =~ /^\s+([\w_\.\/]+)/)) {
			    $localinterface = $1 ;
			    unless ($localinterface =~ /\b(subroutine|function)\b/i) {
# Ceci dfinit une nouvelle interface que l'on peut considrer comme
# une routine appelable directement.
# Tout ce qui suivra cette dfinition d'interface sera considr comme
# un appel.
# Attention, ceci ne sera pas le cas lorque l'interface n'aura pas de nom.
				if ($interface == 1) {
				    $father{"$localinterface:$file:$."} = $Routine ;
#				push(@{$sons{"$Routine"}},"$localinterface:$file:$.") ;
				    ${$sons{"$Routine"}}{$localinterface} = "$localinterface:$file:$." ;
				    print "interface($Routine){$localinterface}=$localinterface:$file:$.\n" if $debug;
			         }
				
			    }
			}
		    }
		    if ($instruction =~ /^\s*(contains)/i) {
			$contains = $contains + 1 ;
			print "contains level upgrades to $contains line $.\n" if $debug;;
		    }
		    if ($instruction =~ /^\s*use\s+([\w_\.\/]+)(.*)/i) {
			$use = $1 ;
			$instruction = $2 ;
			$onlymodule = 0 ;
# Ce niveau est vital en phase d'analyse des appels.
# Il faudra tenir compte des fils du package $use avec leurs
# ventuels alias et restrictions comme faisant partie des
# appels possibles de $Routine.
		    }
		    if ($use) {
			$use=Use_Analysis($use,$instruction) ;
		    }
		}
	    }
	    $NBL{$file}=$.;
	    close(FILE) ;
	}
	(@listerest)=(@listebis);
	(@listehf90)=(@listehf90,@listebis);
    }
    print "\n";
}
